#include "stdafx.h"

#define N 100000

void FillArray(int *a, int n)
{
	for (int i = 0; i < n; i++) a[i] = rand();
}

void PrintArray(int *a, int n)
{
	for (int i = 0; i < n; i++) printf("%8d", a[i]); 
	printf("\n");
}

int swap(int *x, int *y)
{
	int z = *x; *x = *y; *y = z;
	return 0;
}

void SortArray(int *a, int n)
{
	int L = 0;
	int R = n;
	int f;
	
	while (true)
	{
		f = 1; // ===>>>>
		for (int i = L; i < R - 1; i++)
			if (a[i]>a[i + 1])
				f = swap(&a[i], &a[i + 1]);
		if (f) break;
		R--;

		f = 1; // <<<<====
		for (int i = R - 1; i >= L; i--)
			if (a[i]>a[i + 1])
				f = swap(&a[i], &a[i + 1]);
		if (f) break;
		L++;
	}
}



int _tmain(int argc, _TCHAR* argv[])
{
	int a[N];
	FillArray(a, N); 
	PrintArray(a, N);
	SortArray(a, N);
	PrintArray(a, N);
	return 0;
}

